GIT – FreeSWITCH

Freeswitch is an open source communications platform. Like telecommunications and Voice over Internet Protocol (VoIP). Click here for more information of FREESWITCH.

Currently we are using, flavor
Run of following commands

apt-get update
apt-get install upgrade

Install required packages;

apt-get install libjpeg62-dev build-essential subversion subversion-tools automake1.9 gcc-4.1 autoconf make wget libtool g++ libncurses5 libncurses5-dev libcurl4-openssl-dev libexpat1-dev libgnutls-dev libtiff4-dev libx11-dev unixodbc-dev libssl-dev python2.6-dev zlib1g-dev libzrtpcpp-dev libasound2-dev libogg-dev libvorbis-dev libperl-dev libgdbm-dev libdb-dev python-dev uuid-dev autoconf libnewt-dev libnewt-dev git-core build-essential autoconf automake libtool libncurses5 libncurses5-dev make libjpeg-dev pkg-config unixodbc unixodbc-de

FreeSWITCH
You can download FreeSWITCH source codes from:http://files.freeswitch.org/freeswitch-snapshot.tar.gz

cd /usr/src
wget http://files.freeswitch.org/freeswitch-snapshot.tar.gz
tar -zxvf freeswitch-snapshot.tar.gz
mv freeswitch-snapshot freeswitch

1. Configure Freeswitch source code
Goto /usr/src/freeswitch directory and run ./configure. It will configure make files according to your OS specs.

2. Make binaries
Run make command to make bianaries

3. Install FreeSWITCH
If you did not have any problem with make binaries, now its time to install your FreeSWITCH. Run make install command and it will install your FreeSWITCH under /usr/local/freeswitch directory.

4. Install sound files
Run make sounds-install moh-install to install FreeSWITCH’s default sound file.

Make Extensions after complete installation.

cd /usr/local/freeswitch/conf/directory/default

Create new extension file

vi 1111.xml

Your extension file should look something like:

<include>
<user id=”1111″ mailbox=”1111″>
<params>
<param name=”password” value=”11111″/>
<param name=”vm-password” value=”1111″/>
</params>
<variables>
<variable name=”accountcode” value=”1111″/>
<variable name=”user_context” value=”default”/>
<variable name=”effective_caller_id_name” value=”Extension 1111″/>
<variable name=”effective_caller_id_number” value=”1111″/>
</variables>
</user>
</include>

Then create the file /etc/init.d/freeswitch with the following code.

adduser –disabled-password  –quiet –system –home /usr/local/freeswitch –gecos “FreeSWITCH Voice Platform” –ingroup daemon freeswitch
chown -R freeswitch:daemon /usr/local/freeswitch/
chmod -R o-rwx /usr/local/freeswitch/

vi /etc/init.d/freeswitch
==============================================================================
#! /bin/sh
### BEGIN INIT INFO
# Provides:          skeleton
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Description:       Freeswitch init script.
# Author: Matthew Williams
#
### END INIT INFO
# Do NOT “set -e”

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/bin
DESC=”Freeswitch”
NAME=freeswitch
DAEMON=/usr/local/freeswitch/bin/$NAME
DAEMON_ARGS=”-nc”
PIDFILE=/usr/local/freeswitch/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

FS_USER=freeswitch
FS_GROUP=freeswitch

# Exit if the package is not installed
[ -x “$DAEMON” ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that sets ulimit values for the daemon
#
do_setlimits() {
ulimit -c unlimited
ulimit -d unlimited
ulimit -f unlimited
ulimit -i unlimited
ulimit -n 999999
ulimit -q unlimited
ulimit -u unlimited
ulimit -v unlimited
ulimit -x unlimited
ulimit -s 240
ulimit -l unlimited
return 0
}

#
# Function that starts the daemon/service
#
do_start()
{
# Set user to run as
if [ $FS_USER ] ; then
DAEMON_ARGS=”`echo $DAEMON_ARGS` -u $FS_USER”
fi
# Set group to run as
if [ $FS_GROUP ] ; then
DAEMON_ARGS=”`echo $DAEMON_ARGS` -g $FS_GROUP”
fi

# Return
#   0 if daemon has been started
#   1 if daemon was already running
#   2 if daemon could not be started
start-stop-daemon –start –quiet –pidfile $PIDFILE –exec $DAEMON –test > /dev/null — \
|| return 1
do_setlimits
start-stop-daemon –start –quiet –pidfile $PIDFILE –exec $DAEMON — \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
# Return
#   0 if daemon has been stopped
#   1 if daemon was already stopped
#   2 if daemon could not be stopped
#   other if a failure occurred
start-stop-daemon –stop –quiet –retry=TERM/30/KILL/5 –pidfile $PIDFILE –name $NAME
RETVAL=”$?”
[ “$RETVAL” = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently.  A last resort is to
# sleep for some time.
start-stop-daemon –stop –quiet –oknodo –retry=0/30/KILL/5 –exec $DAEMON
[ “$?” = 2 ] && return 2
# Many daemons don’t delete their pidfiles when they exit.
rm -f $PIDFILE
return “$RETVAL”
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon –stop –signal 1 –quiet –pidfile $PIDFILE –name $NAME
return 0
}

case “$1″ in
start)
[ “$VERBOSE” != no ] && log_daemon_msg “Starting $DESC” “$NAME”
do_start
case “$?” in
0|1) [ “$VERBOSE” != no ] && log_end_msg 0 ;;
2) [ “$VERBOSE” != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ “$VERBOSE” != no ] && log_daemon_msg “Stopping $DESC” “$NAME”
do_stop
case “$?” in
0|1) [ “$VERBOSE” != no ] && log_end_msg 0 ;;
2) [ “$VERBOSE” != no ] && log_end_msg 1 ;;
esac
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave ‘force-reload’ as an alias for ‘restart’.
#
#log_daemon_msg “Reloading $DESC” “$NAME”
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the “reload” option is implemented then remove the
# ‘force-reload’ alias
#
log_daemon_msg “Restarting $DESC” “$NAME”
do_stop
case “$?” in
0|1)
do_start
case “$?” in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo “Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}” >&2
echo “Usage: $SCRIPTNAME {start|stop|restart|force-reload}” >&2
exit 3
;;
esac
=======================================================================

Then don’t forget to do the following commands:

chmod +x /etc/init.d/freeswitch
update-rc.d freeswitch defaults

Now you are able to start, stop and restart the service of freeswitch. Start freeswtich service for following command

/etc/init.d/freeswitch restart

Print Friendly

Comments

comments

Bài viết liên quan